<template>
  <div ref="chartRef" style="width: 100%; min-height: 500px"></div>
</template>

<script lang="ts">
import { api } from 'src/boot/axios/index';
import { defineComponent, onMounted, Ref, ref } from 'vue';

import * as echarts from 'echarts';

import { AxiosResponse } from 'axios';
import { GraficoTortaInterface } from 'src/interfaces/VariosInterface';

export default defineComponent({
  props: {
    url: {
      type: String,
      required: true,
    },
    descripcion: {
      type: String,
      required: false,
    },

    legenda: {
      type: Boolean,
      default: true,
      required: false,
    },
  },

  setup(props) {
    const chartRef: Ref<HTMLDivElement | null> = ref(null);
    var chartInstance: echarts.ECharts | null = null;

    const option = ref<echarts.EChartsOption>({
      // visualMap <= si habilito el visualMap, no muestra los colores de las barras !
      series: [],
      tooltip: {
        trigger: 'item',
      },
    });

    onMounted(() => {
      getData();
    });

    function getData() {
      if (props.legenda) {
        option.value.legend = {
          orient: 'vertical',
          left: 'left',
        };
      }

      api
        .get(props.url)
        .then((response: AxiosResponse) => {
          // Defino el nombre de las columnas !!!

          // Cargo los datos !
          option.value.series = [
            {
              type: 'pie',
              radius: [40, 200],
              center: ['50%', '50%'],
              roseType: 'area',
              label: {
                show: true,
              },
              data: response.data.map(function (item: GraficoTortaInterface) {
                return { value: item.total, name: item.nombre };
              }),
              itemStyle: {
                // Configuración de colores para cada barra
                color: function (params) {
                  if (response.data[0].color === undefined) {
                    let color =
                      '#' +
                      ((Math.random() * 0xffffff) << 0)
                        .toString(16)
                        .padStart(6, '0');
                    return color;
                  } else {
                    var colorList = response.data.map(
                      (item: GraficoTortaInterface) => item.color
                    );
                    return colorList[params.dataIndex];
                  }
                },
              },

              emphasis: {
                // Genera efecto sombreado cuando paso x arriba
                itemStyle: {
                  shadowBlur: 10,
                  shadowOffsetX: 0,
                  shadowColor: 'rgba(0, 0, 0, 0.5)',
                },
              },
            },
          ];
        })
        .finally(() => {
          chartInstance = echarts.init(chartRef.value as HTMLDivElement);
          chartInstance.setOption(option.value);
        });
    }

    return {
      chartRef,
      option,
    };
  },
});
</script>
